/*
 *   This file is a part of the SteamWar software.
 *
 *   Copyright (C) 2025 SteamWar.de-Serverteam
 *
 *   This program is free software: you can redistribute it and/or modify
 *   it under the terms of the GNU Affero General Public License as published by
 *   the Free Software Foundation, either version 3 of the License, or
 *   (at your option) any later version.
 *
 *   This program is distributed in the hope that it will be useful,
 *   but WITHOUT ANY WARRANTY; without even the implied warranty of
 *   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the
 *   GNU Affero General Public License for more details.
 *
 *   You should have received a copy of the GNU Affero General Public License
 *   along with this program.  If not, see <https://www.gnu.org/licenses/>.
 */

package de.steamwar.bausystem.features.observer;

import de.steamwar.bausystem.BauSystem;
import de.steamwar.command.SWCommand;
import de.steamwar.core.SWPlayer;
import de.steamwar.linkage.Linked;
import org.bukkit.entity.Player;

@Linked
public class ObserverTracerCommand extends SWCommand {

    public ObserverTracerCommand() {
        super("observertracer", "observer");
        addDefaultHelpMessage("OBSERVER_HELP");
    }

    @Register(value = "enable", description = "OBSERVER_HELP_ENABLE")
    public void enable(Player p) {
        ObserverTracerListener.enabled.add(p);
        BauSystem.MESSAGE.send("OBSERVER_ENABLE", p);
    }

    @Register(value = "disable", description = "OBSERVER_HELP_DISABLE")
    public void disable(Player p) {
        ObserverTracerListener.enabled.remove(p);
        SWPlayer.of(p).removeComponent(ObserverTracer.class);
        BauSystem.MESSAGE.send("OBSERVER_DISABLE", p);
    }

    @Register(value = "delete", description = "OBSERVER_HELP_DELETE")
    public void delete(@Validator Player p) {
        SWPlayer.of(p).removeComponent(ObserverTracer.class);
        BauSystem.MESSAGE.send("OBSERVER_DELETE", p);
    }

    @Register(value = "retrace", description = "OBSERVER_HELP_RETRACE")
    public void retrace(@Validator Player p) {
        if (SWPlayer.of(p).hasComponent(ObserverTracer.class)) {
            BauSystem.MESSAGE.send("OBSERVER_RETRACE_NO_TRACE", p);
            return;
        }
        SWPlayer.of(p).getComponent(ObserverTracer.class).ifPresent(ObserverTracer::trace);
        BauSystem.MESSAGE.send("OBSERVER_RETRACE_DONE", p);
    }
}
